Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 4276)
@@ -162,16 +162,16 @@
 
    ! Arrays used in mpp_lbc_north_3d()
-   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   ztab, znorthloc
-   REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, SAVE   ::   znorthgloio
-   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   zfoldwk      ! Workspace for message transfers avoiding mpi_allgather
+   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   tab_3d, xnorthloc
+   REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, SAVE   ::   xnorthgloio
+   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   foldwk      ! Workspace for message transfers avoiding mpi_allgather
 
    ! Arrays used in mpp_lbc_north_2d()
-   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   ztab_2d, znorthloc_2d
-   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   znorthgloio_2d
-   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   zfoldwk_2d    ! Workspace for message transfers avoiding mpi_allgather
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   tab_2d, xnorthloc_2d
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   xnorthgloio_2d
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   foldwk_2d    ! Workspace for message transfers avoiding mpi_allgather
 
    ! Arrays used in mpp_lbc_north_e()
-   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   ztab_e, znorthloc_e
-   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   znorthgloio_e
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   tab_e, xnorthloc_e
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   xnorthgloio_e
 
    ! North fold arrays used to minimise the use of allgather operations. Set in nemo_northcomms (nemogcm) so need to be public
@@ -207,11 +207,11 @@
          &      t2p1(jpi,jprecj    ,2)   , t2p2(jpi,jprecj    ,2)   ,                                            &
          !
-         &      ztab(jpiglo,4,jpk) , znorthloc(jpi,4,jpk) , znorthgloio(jpi,4,jpk,jpni) ,                        &
-         &      zfoldwk(jpi,4,jpk) ,                                                                             &
-         !
-         &      ztab_2d(jpiglo,4)  , znorthloc_2d(jpi,4)  , znorthgloio_2d(jpi,4,jpni)  ,                        &
-         &      zfoldwk_2d(jpi,4)  ,                                                                             &
-         !
-         &      ztab_e(jpiglo,4+2*jpr2dj) , znorthloc_e(jpi,4+2*jpr2dj) , znorthgloio_e(jpi,4+2*jpr2dj,jpni) ,   &
+         &      tab_3d(jpiglo,4,jpk) , xnorthloc(jpi,4,jpk) , xnorthgloio(jpi,4,jpk,jpni) ,                        &
+         &      foldwk(jpi,4,jpk) ,                                                                             &
+         !
+         &      tab_2d(jpiglo,4)  , xnorthloc_2d(jpi,4)  , xnorthgloio_2d(jpi,4,jpni)  ,                        &
+         &      foldwk_2d(jpi,4)  ,                                                                             &
+         !
+         &      tab_e(jpiglo,4+2*jpr2dj) , xnorthloc_e(jpi,4+2*jpr2dj) , xnorthgloio_e(jpi,4+2*jpr2dj,jpni) ,   &
          !
          &      STAT=lib_mpp_alloc )
@@ -2179,9 +2179,9 @@
 !!gm Remark : this is very time consumming!!!
       !                                         ! ------------------------ !
-            IF( ijpt0 > ijpt1 .OR. iipt0 > iipt1 ) THEN
+        IF(((nbondi .ne. 0) .AND. (ktype .eq. 2)) .OR. ((nbondj .ne. 0) .AND. (ktype .eq. 1))) THEN
             ! there is nothing to be migrated
-               lmigr = .FALSE.
+              lmigr = .TRUE.
             ELSE
-              lmigr = .TRUE.
+              lmigr = .FALSE.
             ENDIF
 
@@ -2598,12 +2598,12 @@
       ityp = -1
       ijpjm1 = 3
-      ztab(:,:,:) = 0.e0
-      !
-      DO jj = nlcj - ijpj +1, nlcj          ! put in znorthloc the last 4 jlines of pt3d
+      tab_3d(:,:,:) = 0.e0
+      !
+      DO jj = nlcj - ijpj +1, nlcj          ! put in xnorthloc the last 4 jlines of pt3d
          ij = jj - nlcj + ijpj
-         znorthloc(:,ij,:) = pt3d(:,jj,:)
+         xnorthloc(:,ij,:) = pt3d(:,jj,:)
       END DO
       !
-      !                                     ! Build in procs of ncomm_north the znorthgloio
+      !                                     ! Build in procs of ncomm_north the xnorthgloio
       itaille = jpi * jpk * ijpj
       IF ( l_north_nogather ) THEN
@@ -2615,5 +2615,5 @@
             ij = jj - nlcj + ijpj
             DO ji = 1, nlci
-               ztab(ji+nimpp-1,ij,:) = pt3d(ji,jj,:)
+               tab_3d(ji+nimpp-1,ij,:) = pt3d(ji,jj,:)
             END DO
          END DO
@@ -2640,8 +2640,8 @@
 
             DO jr = 1,nsndto(ityp)
-               CALL mppsend(5, znorthloc, itaille, isendto(jr,ityp), ml_req_nf(jr) )
+               CALL mppsend(5, xnorthloc, itaille, isendto(jr,ityp), ml_req_nf(jr) )
             END DO
             DO jr = 1,nsndto(ityp)
-               CALL mpprecv(5, zfoldwk, itaille, isendto(jr,ityp))
+               CALL mpprecv(5, foldwk, itaille, isendto(jr,ityp))
                iproc = isendto(jr,ityp) + 1
                ildi = nldit (iproc)
@@ -2650,5 +2650,5 @@
                DO jj = 1, ijpj
                   DO ji = ildi, ilei
-                     ztab(ji+iilb-1,jj,:) = zfoldwk(ji,jj,:)
+                     tab_3d(ji+iilb-1,jj,:) = foldwk(ji,jj,:)
                   END DO
                END DO
@@ -2665,6 +2665,6 @@
 
       IF ( ityp .lt. 0 ) THEN
-         CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
-            &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+         CALL MPI_ALLGATHER( xnorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
+            &                xnorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
          DO jr = 1, ndim_rank_north         ! recover the global north array
@@ -2675,5 +2675,5 @@
             DO jj = 1, ijpj
                DO ji = ildi, ilei
-                  ztab(ji+iilb-1,jj,:) = znorthgloio(ji,jj,:,jr)
+                  tab_3d(ji+iilb-1,jj,:) = xnorthgloio(ji,jj,:,jr)
                END DO
             END DO
@@ -2681,5 +2681,5 @@
       ENDIF
       !
-      ! The ztab array has been either:
+      ! The tab_3d array has been either:
       !  a. Fully populated by the mpi_allgather operation or
       !  b. Had the active points for this domain and northern neighbours populated
@@ -2688,10 +2688,10 @@
       ! this domain will be identical.
       !
-      CALL lbc_nfd( ztab, cd_type, psgn )   ! North fold boundary condition
+      CALL lbc_nfd( tab_3d, cd_type, psgn )   ! North fold boundary condition
       !
       DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
          ij = jj - nlcj + ijpj
          DO ji= 1, nlci
-            pt3d(ji,jj,:) = ztab(ji+nimpp-1,ij,:)
+            pt3d(ji,jj,:) = tab_3d(ji+nimpp-1,ij,:)
          END DO
       END DO
@@ -2730,12 +2730,12 @@
       ityp = -1
       ijpjm1 = 3
-      ztab_2d(:,:) = 0.e0
-      !
-      DO jj = nlcj-ijpj+1, nlcj             ! put in znorthloc_2d the last 4 jlines of pt2d
+      tab_2d(:,:) = 0.e0
+      !
+      DO jj = nlcj-ijpj+1, nlcj             ! put in xnorthloc_2d the last 4 jlines of pt2d
          ij = jj - nlcj + ijpj
-         znorthloc_2d(:,ij) = pt2d(:,jj)
+         xnorthloc_2d(:,ij) = pt2d(:,jj)
       END DO
 
-      !                                     ! Build in procs of ncomm_north the znorthgloio_2d
+      !                                     ! Build in procs of ncomm_north the xnorthgloio_2d
       itaille = jpi * ijpj
       IF ( l_north_nogather ) THEN
@@ -2747,5 +2747,5 @@
             ij = jj - nlcj + ijpj
             DO ji = 1, nlci
-               ztab_2d(ji+nimpp-1,ij) = pt2d(ji,jj)
+               tab_2d(ji+nimpp-1,ij) = pt2d(ji,jj)
             END DO
          END DO
@@ -2773,8 +2773,8 @@
 
             DO jr = 1,nsndto(ityp)
-               CALL mppsend(5, znorthloc_2d, itaille, isendto(jr,ityp), ml_req_nf(jr) )
+               CALL mppsend(5, xnorthloc_2d, itaille, isendto(jr,ityp), ml_req_nf(jr) )
             END DO
             DO jr = 1,nsndto(ityp)
-               CALL mpprecv(5, zfoldwk_2d, itaille, isendto(jr,ityp))
+               CALL mpprecv(5, foldwk_2d, itaille, isendto(jr,ityp))
                iproc = isendto(jr,ityp) + 1
                ildi = nldit (iproc)
@@ -2783,5 +2783,5 @@
                DO jj = 1, ijpj
                   DO ji = ildi, ilei
-                     ztab_2d(ji+iilb-1,jj) = zfoldwk_2d(ji,jj)
+                     tab_2d(ji+iilb-1,jj) = foldwk_2d(ji,jj)
                   END DO
                END DO
@@ -2798,6 +2798,6 @@
 
       IF ( ityp .lt. 0 ) THEN
-         CALL MPI_ALLGATHER( znorthloc_2d  , itaille, MPI_DOUBLE_PRECISION,        &
-            &                znorthgloio_2d, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+         CALL MPI_ALLGATHER( xnorthloc_2d  , itaille, MPI_DOUBLE_PRECISION,        &
+            &                xnorthgloio_2d, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
          DO jr = 1, ndim_rank_north            ! recover the global north array
@@ -2808,5 +2808,5 @@
             DO jj = 1, ijpj
                DO ji = ildi, ilei
-                  ztab_2d(ji+iilb-1,jj) = znorthgloio_2d(ji,jj,jr)
+                  tab_2d(ji+iilb-1,jj) = xnorthgloio_2d(ji,jj,jr)
                END DO
             END DO
@@ -2814,5 +2814,5 @@
       ENDIF
       !
-      ! The ztab array has been either:
+      ! The tab array has been either:
       !  a. Fully populated by the mpi_allgather operation or
       !  b. Had the active points for this domain and northern neighbours populated
@@ -2821,5 +2821,5 @@
       ! this domain will be identical.
       !
-      CALL lbc_nfd( ztab_2d, cd_type, psgn )   ! North fold boundary condition
+      CALL lbc_nfd( tab_2d, cd_type, psgn )   ! North fold boundary condition
       !
       !
@@ -2827,5 +2827,5 @@
          ij = jj - nlcj + ijpj
          DO ji = 1, nlci
-            pt2d(ji,jj) = ztab_2d(ji+nimpp-1,ij)
+            pt2d(ji,jj) = tab_2d(ji+nimpp-1,ij)
          END DO
       END DO
@@ -2860,18 +2860,18 @@
       !
       ijpj=4
-      ztab_e(:,:) = 0.e0
+      tab_e(:,:) = 0.e0
 
       ij=0
-      ! put in znorthloc_e the last 4 jlines of pt2d
+      ! put in xnorthloc_e the last 4 jlines of pt2d
       DO jj = nlcj - ijpj + 1 - jpr2dj, nlcj +jpr2dj
          ij = ij + 1
          DO ji = 1, jpi
-            znorthloc_e(ji,ij)=pt2d(ji,jj)
+            xnorthloc_e(ji,ij)=pt2d(ji,jj)
          END DO
       END DO
       !
       itaille = jpi * ( ijpj + 2 * jpr2dj )
-      CALL MPI_ALLGATHER( znorthloc_e(1,1)  , itaille, MPI_DOUBLE_PRECISION,    &
-         &                znorthgloio_e(1,1,1), itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+      CALL MPI_ALLGATHER( xnorthloc_e(1,1)  , itaille, MPI_DOUBLE_PRECISION,    &
+         &                xnorthgloio_e(1,1,1), itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
       !
       DO jr = 1, ndim_rank_north            ! recover the global north array
@@ -2882,5 +2882,5 @@
          DO jj = 1, ijpj+2*jpr2dj
             DO ji = ildi, ilei
-               ztab_e(ji+iilb-1,jj) = znorthgloio_e(ji,jj,jr)
+               tab_e(ji+iilb-1,jj) = xnorthgloio_e(ji,jj,jr)
             END DO
          END DO
@@ -2890,5 +2890,5 @@
       ! 2. North-Fold boundary conditions
       ! ----------------------------------
-      CALL lbc_nfd( ztab_e(:,:), cd_type, psgn, pr2dj = jpr2dj )
+      CALL lbc_nfd( tab_e(:,:), cd_type, psgn, pr2dj = jpr2dj )
 
       ij = jpr2dj
@@ -2897,5 +2897,5 @@
       ij  = ij +1
          DO ji= 1, nlci
-            pt2d(ji,jj) = ztab_e(ji+nimpp-1,ij)
+            pt2d(ji,jj) = tab_e(ji+nimpp-1,ij)
          END DO
       END DO
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/LBC/mppini_2.h90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/LBC/mppini_2.h90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/LBC/mppini_2.h90	(revision 4276)
@@ -122,4 +122,12 @@
       irestj = 1 + MOD( jpjglo - nrecj -1 , jpnj )
 
+#if defined key_nemocice_decomp
+      ! Change padding to be consistent with CICE
+      ilci(1:jpni-1      ,:) = jpi
+      ilci(jpni          ,:) = jpiglo - (jpni - 1) * (jpi - nreci)
+
+      ilcj(:,      1:jpnj-1) = jpj
+      ilcj(:,          jpnj) = jpjglo - (jpnj - 1) * (jpj - nrecj)
+#else
       ilci(1:iresti      ,:) = jpi
       ilci(iresti+1:jpni ,:) = jpi-1
@@ -127,4 +135,5 @@
       ilcj(:,      1:irestj) = jpj
       ilcj(:, irestj+1:jpnj) = jpj-1
+#endif
 
       IF(lwp) WRITE(numout,*)
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 4276)
@@ -187,5 +187,5 @@
          &      gsinf(jpi,jpj), gcosf(jpi,jpj), STAT=ierr )
       IF(lk_mpp)   CALL mpp_sum( ierr )
-      IF( ierr /= 0 )   CALL ctl_stop('STOP', 'angle_msh_geo: unable to allocate arrays' )
+      IF( ierr /= 0 )   CALL ctl_stop('angle: unable to allocate arrays' )
 
       ! ============================= !
@@ -361,5 +361,5 @@
             &      gsinlat(jpi,jpj,4) , gcoslat(jpi,jpj,4) , STAT=ierr )
          IF( lk_mpp    )   CALL mpp_sum( ierr )
-         IF( ierr /= 0 )   CALL ctl_stop('STOP', 'angle_msh_geo: unable to allocate arrays' )
+         IF( ierr /= 0 )   CALL ctl_stop('geo2oce: unable to allocate arrays' )
       ENDIF
 
@@ -438,9 +438,9 @@
       !!----------------------------------------------------------------------
 
-      IF( ALLOCATED( gsinlon ) ) THEN
+      IF( .NOT. ALLOCATED( gsinlon ) ) THEN
          ALLOCATE( gsinlon(jpi,jpj,4) , gcoslon(jpi,jpj,4) ,   &
             &      gsinlat(jpi,jpj,4) , gcoslat(jpi,jpj,4) , STAT=ierr )
          IF( lk_mpp    )   CALL mpp_sum( ierr )
-         IF( ierr /= 0 )   CALL ctl_stop('STOP', 'angle_msh_geo: unable to allocate arrays' )
+         IF( ierr /= 0 )   CALL ctl_stop('oce2geo: unable to allocate arrays' )
       ENDIF
 
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 4276)
@@ -72,4 +72,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sfx    , sfx_b    !: salt flux                                    [PSU/m2/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   emp_tot           !: total E-P over ocean and ice                 [Kg/m2/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   fmmflx            !: freshwater budget: freezing/melting          [Kg/m2/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   rnf    , rnf_b    !: river runoff   [Kg/m2/s]  
    !!
@@ -117,5 +118,5 @@
          &      qsr_tot(jpi,jpj) , qsr  (jpi,jpj) ,                        &
          &      emp    (jpi,jpj) , emp_b(jpi,jpj) ,                        &
-         &      sfx    (jpi,jpj) , sfx_b(jpi,jpj) , emp_tot(jpi,jpj) , STAT=ierr(2) )
+         &      sfx    (jpi,jpj) , sfx_b(jpi,jpj) , emp_tot(jpi,jpj), fmmflx(jpi,jpj), STAT=ierr(2) )
          !
       ALLOCATE( rnf  (jpi,jpj) , sbc_tsc  (jpi,jpj,jpts) , qsr_hc  (jpi,jpj,jpk) ,     &
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4276)
@@ -407,5 +407,7 @@
       SELECT CASE( TRIM( sn_rcv_emp%cldes ) )
       CASE( 'oce only'      )   ;   srcv(                                 jpr_oemp   )%laction = .TRUE. 
-      CASE( 'conservative'  )   ;   srcv( (/jpr_rain, jpr_snow, jpr_ievp, jpr_tevp/) )%laction = .TRUE.
+      CASE( 'conservative'  )
+         srcv( (/jpr_rain, jpr_snow, jpr_ievp, jpr_tevp/) )%laction = .TRUE.
+         IF ( k_ice <= 1 )  srcv(jpr_ivep)%laction = .FALSE.
       CASE( 'oce and ice'   )   ;   srcv( (/jpr_ievp, jpr_sbpr, jpr_semp, jpr_oemp/) )%laction = .TRUE.
       CASE default              ;   CALL ctl_stop( 'sbc_cpl_init: wrong definition of sn_rcv_emp%cldes' )
@@ -465,13 +467,4 @@
          CALL ctl_stop( 'sbc_cpl_init: namsbc_cpl namelist mismatch between sn_rcv_qns%cldes and sn_rcv_dqnsdt%cldes' )
       !                                                      ! ------------------------- !
-      !                                                      !    Ice Qsr penetration    !   
-      !                                                      ! ------------------------- !
-      ! fraction of net shortwave radiation which is not absorbed in the thin surface layer 
-      ! and penetrates inside the ice cover ( Maykut and Untersteiner, 1971 ; Elbert anbd Curry, 1993 )
-      ! Coupled case: since cloud cover is not received from atmosphere 
-      !               ===> defined as constant value -> definition done in sbc_cpl_init
-      fr1_i0(:,:) = 0.18
-      fr2_i0(:,:) = 0.82
-      !                                                      ! ------------------------- !
       !                                                      !      10m wind module      !   
       !                                                      ! ------------------------- !
@@ -508,4 +501,9 @@
       ! Allocate taum part of frcv which is used even when not received as coupling field
       IF ( .NOT. srcv(jpr_taum)%laction ) ALLOCATE( frcv(jpr_taum)%z3(jpi,jpj,srcv(jn)%nct) )
+      ! Allocate itx1 and ity1 as they are used in sbc_cpl_ice_tau even if srcv(jpr_itx1)%laction = .FALSE.
+      IF( k_ice /= 0 ) THEN
+         IF ( .NOT. srcv(jpr_itx1)%laction ) ALLOCATE( frcv(jpr_itx1)%z3(jpi,jpj,srcv(jn)%nct) )
+         IF ( .NOT. srcv(jpr_ity1)%laction ) ALLOCATE( frcv(jpr_ity1)%z3(jpi,jpj,srcv(jn)%nct) )
+      END IF
 
       ! ================================ !
@@ -911,8 +909,8 @@
       !!                 third  as  2 components on the cp_ice_msh point 
       !!
-      !!                In 'oce and ice' case, only one vector stress field 
+      !!                Except in 'oce and ice' case, only one vector stress field 
       !!             is received. It has already been processed in sbc_cpl_rcv
       !!             so that it is now defined as (i,j) components given at U-
-      !!             and V-points, respectively. Therefore, here only the third
+      !!             and V-points, respectively. Therefore, only the third
       !!             transformation is done and only if the ice-grid is a 'I'-grid. 
       !!
@@ -1329,4 +1327,13 @@
       END SELECT
 
+      !    Ice Qsr penetration used (only?)in lim2 or lim3 
+      ! fraction of net shortwave radiation which is not absorbed in the thin surface layer 
+      ! and penetrates inside the ice cover ( Maykut and Untersteiner, 1971 ; Elbert anbd Curry, 1993 )
+      ! Coupled case: since cloud cover is not received from atmosphere 
+      !               ===> defined as constant value -> definition done in sbc_cpl_init
+      fr1_i0(:,:) = 0.18
+      fr2_i0(:,:) = 0.82
+
+
       CALL wrk_dealloc( jpi,jpj, zcptn, ztmp, zicefr )
       !
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 4276)
@@ -146,4 +146,6 @@
       sfx(:,:) = 0.0_wp                            ! the salt flux due to freezing/melting will be computed (i.e. will be non-zero) 
                                                    ! only if sea-ice is present
+ 
+      fmmflx(:,:) = 0.0_wp                        ! freezing-melting array initialisation
 
       !                                            ! restartability   
@@ -218,4 +220,6 @@
          IF( nsbc ==  6 )   WRITE(numout,*) '              MFS Bulk formulation'
       ENDIF
+      !
+                          CALL sbc_ssm_init               ! Sea-surface mean fields initialisation
       !
       IF( ln_ssr      )   CALL sbc_ssr_init               ! Sea-Surface Restoring initialisation
@@ -362,4 +366,5 @@
                                                                 ! (includes virtual salt flux beneath ice 
                                                                 ! in linear free surface case)
+         CALL iom_put( "fmmflx", fmmflx  )                      ! Freezing-melting water flux
          CALL iom_put( "qt"    , qns  + qsr )                   ! total heat flux 
          CALL iom_put( "qns"   , qns        )                   ! solar heat flux
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90	(revision 4276)
@@ -30,4 +30,5 @@
    USE lbclnk          ! lateral boudary conditions
    USE lib_mpp         ! distributed memory computing
+   USE c1d               ! 1D vertical configuration
    USE in_out_manager  ! I/O manager
    USE timing          ! timing
@@ -271,4 +272,5 @@
       
       ! SOR and PCG solvers
+      IF( lk_c1d ) CALL lbc_lnk( gcdmat, 'T', 1._wp ) ! 1D case bmask =/0  but gcdmat not define everywhere 
       DO jj = 1, jpj
          DO ji = 1, jpi
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 4276)
@@ -675,5 +675,5 @@
 
 
-   FUNCTION tfreez( psal ) RESULT( ptf )
+   FUNCTION tfreez( psal, pdep ) RESULT( ptf )
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE eos_init  ***
@@ -688,4 +688,5 @@
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   psal   ! salinity             [psu]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ), OPTIONAL ::   pdep   ! depth      [decibars]
       ! Leave result array automatic rather than making explicitly allocated
       REAL(wp), DIMENSION(jpi,jpj)                ::   ptf    ! freezing temperature [Celcius]
@@ -694,4 +695,7 @@
       ptf(:,:) = ( - 0.0575_wp + 1.710523e-3_wp * SQRT( psal(:,:) )   &
          &                     - 2.154996e-4_wp *       psal(:,:)   ) * psal(:,:)
+      IF ( PRESENT( pdep ) ) THEN   
+         ptf(:,:) = ptf(:,:) - 7.53e-4_wp * pdep(:,:)
+      ENDIF
       !
    END FUNCTION tfreez
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 4276)
@@ -271,5 +271,5 @@
       !
 #if defined key_iomput
-      IF( kstp == nitend   )   CALL xios_context_finalize() ! needed for XIOS+AGRIF
+      IF( kstp == nitend .OR. indic < 0 )   CALL xios_context_finalize() ! needed for XIOS+AGRIF
 #endif
       !
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/daymod.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/daymod.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/daymod.F90	(revision 4276)
@@ -246,4 +246,9 @@
                nday_year = 1
                nsec_year = ndt05
+               IF( nsec1jan000 >= 2 * (2**30 - nsecd * nyear_len(1) / 2 ) ) THEN   ! test integer 4 max value
+                  CALL ctl_stop( 'The number of seconds between Jan. 1st 00h of nit000 year and Jan. 1st 00h ',   &
+                     &           'of the current year is exceeding the INTEGER 4 max VALUE: 2^31-1 -> 68.09 years in seconds', &
+                     & 'You must do a restart at higher frequency (or remove this STOP and recompile everything in I8)' )
+               ENDIF
                nsec1jan000 = nsec1jan000 + nsecd * nyear_len(1)
                IF( nleapy == 1 )   CALL day_mth
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/diawri.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/diawri.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/diawri.F90	(revision 4276)
@@ -259,6 +259,6 @@
          CALL histdef( nid_T, "sowaflup", "Net Upward Water Flux"              , "Kg/m2/s",   &  ! (emp-rnf)
             &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-         CALL histdef( nid_T, "sowaflcd", "concentration/dilution water flux"  , "kg/m2/s",   &  ! (emps-rnf)
-            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
+         CALL histdef( nid_T, "sosfldow", "downward salt flux"                 , "PSU/m2/s",  &  ! (sfx)
+             &         jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
          CALL histdef( nid_T, "sohefldo", "Net Downward Heat Flux"             , "W/m2"   ,   &  ! qns + qsr
             &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
@@ -309,6 +309,9 @@
       CALL histwrite( nid_T, "sst_m", it, sst_m, ndim_hT, ndex_hT )   ! sea surface temperature
       CALL histwrite( nid_T, "sss_m", it, sss_m, ndim_hT, ndex_hT )   ! sea surface salinity
-      CALL histwrite( nid_T, "sowaflup", it, emp   , ndim_hT, ndex_hT )   ! upward water flux
-      CALL histwrite( nid_T, "sowaflcd", it, emps  , ndim_hT, ndex_hT )   ! c/d water flux
+      CALL histwrite( nid_T, "sowaflup", it, (emp - rnf )  , ndim_hT, ndex_hT )   ! upward water flux
+      CALL histwrite( nid_T, "sosfldow", it, sfx           , ndim_hT, ndex_hT )   ! downward salt flux 
+                                                                                  ! (includes virtual salt flux beneath ice 
+                                                                                  ! in linear free surface case)
+
       CALL histwrite( nid_T, "sohefldo", it, qns + qsr     , ndim_hT, ndex_hT )   ! total heat flux
       CALL histwrite( nid_T, "soshfldo", it, qsr           , ndim_hT, ndex_hT )   ! solar heat flux
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90	(revision 4276)
@@ -382,6 +382,7 @@
       USE diawri    , ONLY: dia_wri_alloc
       USE dom_oce   , ONLY: dom_oce_alloc
-      !
-      INTEGER :: ierr
+      USE oce       , ONLY : sshn, sshb, snwice_mass, snwice_mass_b, snwice_fmass 
+      !
+      INTEGER :: ierr,ierr4
       !!----------------------------------------------------------------------
       !
@@ -389,4 +390,7 @@
       ierr = ierr + dom_oce_alloc   ()          ! ocean domain
       ierr = ierr + lib_mpp_alloc   (numout)    ! mpp exchanges
+      ALLOCATE( snwice_mass(jpi,jpj)  , snwice_mass_b(jpi,jpj),             &
+         &      snwice_fmass(jpi,jpj), STAT= ierr4 )
+      ierr = ierr + ierr4
       !
       IF( lk_mpp    )   CALL mpp_sum( ierr )
Index: branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/sbcssm.F90
===================================================================
--- branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/sbcssm.F90	(revision 4275)
+++ branches/2013/dev_r3856_MERCATOR3_QSRMEAN24H/NEMOGCM/NEMO/SAS_SRC/sbcssm.F90	(revision 4276)
@@ -81,4 +81,6 @@
       
       !
+      IF (kt == nn_it000 ) CALL sbc_ssm_init()
+
       IF( nn_timing == 1 )  CALL timing_start( 'sbc_ssm')
 
@@ -100,4 +102,8 @@
       tsn(:,:,1,jp_tem) = sst_m(:,:)
       tsn(:,:,1,jp_sal) = sss_m(:,:)
+      IF ( nn_ice == 1 ) THEN
+         tsb(:,:,1,jp_tem) = sst_m(:,:)
+         tsb(:,:,1,jp_sal) = sss_m(:,:)
+      ENDIF
       ub (:,:,1       ) = ssu_m(:,:)
       vb (:,:,1       ) = ssv_m(:,:)
@@ -135,5 +141,5 @@
       TYPE(FLD_N) :: sn_usp, sn_vsp, sn_ssh
       !
-      NAMELIST/namsbc_ssm/cn_dir, ln_3d_uv, sn_tem, sn_sal, sn_usp, sn_vsp, sn_ssh
+      NAMELIST/namsbc_sas/cn_dir, ln_3d_uv, sn_tem, sn_sal, sn_usp, sn_vsp, sn_ssh
 
       !!----------------------------------------------------------------------
@@ -151,12 +157,12 @@
       !
       REWIND( numnam )                          ! read in namlist namsbc_ssm
-      READ  ( numnam, namsbc_ssm )
+      READ  ( numnam, namsbc_sas )
       !                                         ! store namelist information in an array
       !                                         ! Control print
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) 'sbc_ssm : standalone surface scheme '
+         WRITE(numout,*) 'sbc_sas : standalone surface scheme '
          WRITE(numout,*) '~~~~~~~~~~~ '
-         WRITE(numout,*) '   Namelist namsbc_ssm'
+         WRITE(numout,*) '   Namelist namsbc_sas'
          WRITE(numout,*)
       ENDIF
@@ -273,9 +279,11 @@
       ! so allocate enough of arrays to use
       !
+      ierr3 = 0
       jpm = MAX(jp_tem, jp_sal)
       ALLOCATE( tsn(jpi,jpj,1,jpm), STAT=ierr0 )
       ALLOCATE( ub(jpi,jpj,1)     , STAT=ierr1 )
       ALLOCATE( vb(jpi,jpj,1)     , STAT=ierr2 )
-      ierr = ierr0 + ierr1 + ierr2
+      IF ( nn_ice == 1 ) ALLOCATE( tsb(jpi,jpj,1,jpm), STAT=ierr3 )
+      ierr = ierr0 + ierr1 + ierr2 + ierr3
       IF( ierr > 0 ) THEN
          CALL ctl_stop('sbc_ssm_init: unable to allocate surface arrays')
